/*
Created Nice Kicker by sector for www.chatbox.do.am
Web Help - www.chatbox.do.am

All ingenious is simple - Nice. Made in Russia.
*/

#include <amxmodx>

#define nPlugin "Nice Kicker"

new nPing_Warn[33]

new nK_Flag_Cvar
new nK_Time_Cvar
new nK_Ping_Cvar
new nK_Warn_Cvar

public plugin_init() 
{
	register_plugin(nPlugin, "10", "sector")
	
	register_dictionary("nk.txt")
	
	server_cmd("exec addons/amxmodx/configs/nk.cfg")
	
	nK_Flag_Cvar = register_cvar("nk_flag", "")
	nK_Time_Cvar = register_cvar("nk_time", "")
	nK_Ping_Cvar = register_cvar("nk_ping", "")
	nK_Warn_Cvar = register_cvar("nk_warn", "")
}

public client_putinserver(i)
{
	new nLen[33]
	
	get_pcvar_string(nK_Flag_Cvar, nLen, 32)
	
	if(is_user_hltv(i) || is_user_bot(i) || (strlen(nLen) && get_user_flags(i) & read_flags(nLen)))
		return PLUGIN_HANDLED
		
	nPing_Warn[i] = 0
	
	set_task(get_pcvar_float(nK_Time_Cvar), "nice_kicker_protected", i, _, _, "b")
	
	return PLUGIN_CONTINUE
}

public client_disconnect(i)
{
	if(task_exists(i))
	{
		remove_task(i)
	}
} 

public nice_kicker_protected(i)
{
	new nPing, nLoss
	new nMaxPing = get_pcvar_num(nK_Ping_Cvar)
	
	get_user_ping(i, nPing, nLoss)
	
	if(nPing > nMaxPing)
	{
		new nWarns = get_pcvar_num(nK_Warn_Cvar)
		
		nPing_Warn[i]++
		
		nChatPrint(i, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NK_WARN_MAXPING", nPing, nPing_Warn[i], nWarns)
		
		if(nPing_Warn[i] == nWarns)
		{
			new nName[33], nUid = get_user_userid(i)
			
			get_user_name(i, nName, 32)
			
			nChatPrint(i, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NK_WARN_MES", nName, nPing)
			
			server_cmd("kick #%d ^"[%s] %L^"", nUid, nPlugin, LANG_PLAYER, "NK_REASON", nPing)
		}
	}
	else
	if(nPing < nMaxPing)
	{
		nPing_Warn[i] = 0
	}
}

stock nChatPrint(const id, const input[], any:...)
{
	 new nCount = 1, nNum[32]
	 
	 static nMsgs[191]
	 
	 vformat(nMsgs, 190, input, 3)
	 
	 replace_all(nMsgs, 190, "!g", "^4")
	 replace_all(nMsgs, 190, "!n", "^1")
	 replace_all(nMsgs, 190, "!t", "^3")

	 
	 if(id) nNum[0] = id; else get_players(nNum, nCount, "ch")
	 {
	 	for(new i = 0; i < nCount; i++)
		{
			if(is_user_connected(nNum[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, nNum[i])
				
				write_byte(nNum[i])
				
				write_string(nMsgs)
				
				message_end()
			}
		}
	}
}
